#!/bin/sh
# generates an array of C strings from a text file, using one line of the file per string.

echo "/*******************************************************"
echo " * C string array generation script for Word Factory"
echo " * Written by Jan 'jast' Krueger, 2003."
echo " * See COPYING for license details."
echo " *******************************************************/"
echo ""
echo "  char *mystrings[] = {"

sed "s/^\\(.*\\)\$/    \"&\",/" $1 | sed "s/\\\\/\\\\\\\\/"

echo "    NULL"
echo "  };"
echo ""
echo "int numstrings = $(wc -l $1 | awk '{ print $1 }' );"
