/* Word Factory by Jan 'jast' Krueger
 * creates chains of random words collected by some insane person.
 * Note that I'm a C noob. And I hate rand().
 */

#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "factoryitems.h"

int avlen = 8;
int maxdev = 3;


int main(int argc, char *argv[]) {
	unsigned int i, limit;
	int fd;

	if(argc == 2 && !strcmp(argv[1], "--help")) {
		puts("Word Factory syntax:   wordfactory <average number of words on the line> <maximum deviation>");
		puts("                       Either use both arguments or none or expect horrible failure.");
		puts("                       Note that this code is A Mess (tm).");
		exit(1);
	}

	if(argc == 2 && !strcmp(argv[1], "--version")) {
		puts("Word Factory v0.1, Copyright (C) Jan 'jast' Krueger, 2003.");
		exit(1);
	}

	if(argc == 3) {
		avlen = atoi(argv[1]);
		maxdev = atoi(argv[2]);
	}

	/* I don't think it's supposed to be used like this. */
	fd = open("/dev/urandom", O_RDONLY);
	read(fd, (void *) &i, sizeof(int));
	close(fd);

	i ^= getpid();

	srand(i);
	limit = rand()/(RAND_MAX/(2*maxdev)) + avlen - maxdev + 1;

	for(i = 0; i < limit; i++) {
		int j = rand()/(RAND_MAX/(numstrings));

		printf("%s%s", mystrings[j], (i+1 != limit) ? " " : "");
	}

}
